"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
function mapAggregate(Aaggregate, Baggregate, mapper) {
    var _mutators = Aaggregate.mutators;
    var mutators = __assign({}, _mutators);
    Object.keys(mapper).forEach(function (mutationKey) {
        var type = "" + Baggregate.namespace + mutationKey;
        mutators[type] = mapper[mutationKey];
    });
    function reducerFactory(initialState) {
        return function (state, action) {
            if (state === void 0) { state = initialState; }
            var mutator = mutators[action.type];
            if (typeof mutator !== 'function')
                return state;
            return mutator(state, action.payload);
        };
    }
    return __assign({}, Aaggregate, { reducerFactory: reducerFactory, mutators: mutators });
}
exports.mapAggregate = mapAggregate;
